ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccc                 Calculates the relevant EDMs                  ccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Fromulas taken from arXiv:1102.5679 and arXiv:0808.1819

      subroutine CALC_EDMS(slhafile)
      
      implicit none
      
      character*30 slhafile
      
      double precision dEe_chi,dEd_chi,dEu_chi,dCd_chi,dCu_chi,
     &                 dEe_two,dEu_two,dEd_two,dEe_all,
     &                 dEe_cha,dEd_cha,dEu_cha,dCd_cha,dCu_cha,
     &                 dEd_glu,dEu_glu,dCd_glu,dCu_glu,
     &                 dEs_chi,dEs_cha,dEs_glu
      double precision dEe_gamH0,dEd_gamH0,dEu_gamH0,dEd_WHp,
     &                 dEe_WHp,dEe_WW,dEd_WW,dEu_WW,dEe_ZH,
     &                 dEd_ZH,dEu_ZH,dCd_BZ,dCu_BZ,dG_H,dG_glu,
     &                 dEs_gamH0,dEs_WHp,dEs_WW,dEs_ZH
      double precision dEe_one,dEd_one,dEu_one,dCd_one,dCu_one,
     &                 dG_all,dEs_one,dEs_two
      double precision dTl(6),dnCQM(6),dnQCDsum(7),dnPQM(6),dHg(4)
      
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)
      double precision absM3,phiM3
      double precision ZH5(5,5),ZH(6,6)
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      double complex CLChiFeSe(5,2),CRChiFeSe(5,2),CLChiFdSd(5,4),
     &               CRChiFdSd(5,4),CLChiFuSu(5,2),CRChiFuSu(5,2),
     &               ChStauStau(5,2,2),ChSbSb(5,2,2),ChStSt(5,2,2),
     &               CShChaCha(5,2,2),CPhChaCha(5,2,2)
      double precision CSfdown(5),CPfdown(5),CSfup(5),CPfup(5)
      double complex  CPHpChiCha(5,2),CSHpChiCha(5,2),CLWChiCha(5,2),
     &                 CRWChiCha(5,2),CPHpud(2),CSHpud(2),CSHpve,CPHpve 
      double complex CLChaFdSu(2,4),CRChaFdSu(2,4),CLChaFuSd(2,2),
     &               CRChaFuSd(2,2),CLChaFeSv(2),CRChaFeSv(2),
     &               CLdFgSd(2),CRdFgSd(2),CRuFgSu(2),CLuFgSu(2),
     &               CLbFgSb(2),CRbFgSb(2),CRtFgSt(2),CLtFgSt(2),
     &               CLsFgSs(2),CRsFgSs(2)
      double complex vZuu,aZuu,vZdd,aZdd,vZee,aZee,vZchacha(2,2),
     &               aZchacha(2,2)
      double precision C4de,C4se,C4be,C4bd,C4ge,C4ec,C4et,C4dd,
     &                      C4ds
      double complex convfac
      double precision kap,MSvtemp(2)
      double complex CLChaFeSvtemp(2,2),CRChaFeSvtemp(2,2)
      
      double precision FUNC_EDM
      integer ivegas(4),iprint
      character*7 folder
      character*30 filename
      double precision phase
      integer countvalid,EDMswitch
      double precision runm_hdec,alphas_hdec
      double precision Qs,mtMS,mbMS,mtDR,mbDR,a_sDR
      integer i
      
      double precision pi
      parameter (pi = 2d0*Asin(1d0))
      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /gluino/ absM3,phiM3
      common/ couplingsEDM / CLChiFeSe,CRChiFeSe,CLChiFdSd,CRChiFdSd,
     &                       CLChiFuSu,CRChiFuSu,ChStauStau,ChSbSb,
     &                       ChStSt,CShChaCha,CPhChaCha,CSHpChiCha,
     &                       CPHpChiCha,CLWChiCha,CRWChiCha,
     &                       CSfdown,CPfdown,CSfup,CPfup,
     &                       CPHpud,CSHpud,CSHpve,CPHpve,
     &                       CLChaFdSu,CRChaFdSu,CLChaFuSd,CRChaFuSd,
     &                       CLChaFeSv,CRChaFeSv,CLdFgSd,CRdFgSd,
     &                       CRuFgSu,CLuFgSu,CLbFgSb,CRbFgSb,
     &                       CRtFgSt,CLtFgSt,CLsFgSs,CRsFgSs
      common/ couplingsEDM2/ vZuu,aZuu,vZdd,aZdd,vZee,aZee,vZchacha,
     &                       aZchacha 
      common/fourfermionop/ C4de,C4se,C4be,C4bd,C4ge,C4ec,C4et,C4dd,
     &                      C4ds
      common/inpVEGAS/ivegas,iprint
      common/checkvalid/countvalid
      common /EDMselec/ EDMswitch
      common /scale/ Qs
     
! EDMs need to be evaluated at the EW scale: evolve quark masses to that scale      
      g3=sqrt(alphas_hdec(Mz,3)*4d0*pi)
      ms=runm_hdec(Mz,3)
      mc=runm_hdec(Mz,4)
      mb=runm_hdec(Mz,5)
      mt=runm_hdec(Mz,6)
      
      Yu(1) = mu*sqrt(2d0)/v/Sin(beta)
      Yu(2) = mc*sqrt(2d0)/v/Sin(beta)
      Yu(3) = mt*sqrt(2d0)/v/Sin(beta)
      Yd(1) = md*sqrt(2d0)/v/Cos(beta)
      Yd(2) = ms*sqrt(2d0)/v/Cos(beta)
      Yd(3) = mb*sqrt(2d0)/v/Cos(beta)
      
      call dsquarkmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,phiAd,
     &                   absAd,mq2,mdr2,Yd,MSd,ZD)
          

      call usquarkmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,phiAu,
     &                   absAu,mq2,mur2,Yu,MSu,ZU)
     
! recalcuate the necessary couplings at the EW scale
      call couplings
      call EDM_couplings
      
      convfac=1.9732695d-14 !converts from 1/GeV to cm
      
!one-loop contributions of neutralino loops to electron EDM
      call EDM_dEf_chione(MChi,MSe(1:2),CLChiFeSe,CRChiFeSe,
     &                    -1d0,dEe_chi)
      dEe_chi=dEe_chi*convfac
      
!one-loop contributions of chargino loops to electron EDM
      MSvtemp(1)=MSv(1)
      MSvtemp(2)=0d0
      do i=1,2
      CLChaFeSvtemp(i,1)=CLChaFeSv(i)
      CRChaFeSvtemp(i,1)=CRChaFeSv(i)
      CLChaFeSvtemp(i,2)=0d0
      CRChaFeSvtemp(i,2)=0d0
      end do
      call EDM_dEf_chaone(MCha,MSvtemp,CLChaFeSvtemp,CRChaFeSvtemp,
     &                    0d0,dEe_cha)
      dEe_cha=dEe_cha*convfac
      
!one-loop contributions of neutralino loops to quark EDM
      call EDM_dEf_chione(MChi,MSd(1:2),CLChiFdSd(1:5,1:2),
     &                    CRChiFdSd(1:5,1:2),-1/3d0,dEd_chi)
      dEd_chi=dEd_chi*convfac
      call EDM_dEf_chione(MChi,MSu(1:2),CLChiFuSu,CRChiFuSu,
     &                    2d0/3d0,dEu_chi)
      dEu_chi=dEu_chi*convfac
      call EDM_dEf_chione(MChi,MSd(3:4),CLChiFdSd(1:5,3:4),
     &                    CRChiFdSd(1:5,3:4),-1/3d0,dEs_chi)
      dEs_chi=dEs_chi*convfac
      
      call CEDM_dCq_chione(MChi,MSd(1:2),CLChiFdSd(1:5,1:2),
     .                     CRChiFdSd(1:5,1:2),dCd_chi)
      call CEDM_dCq_chione(MChi,MSu(1:2),CLChiFuSu,CRChiFuSu,dCu_chi)
      dCd_chi=dCd_chi*convfac
      dCu_chi=dCu_chi*convfac
      
!one-loop contributions of chargino loops to quark EDM
      call EDM_dEf_chaone(MCha,MSu(1:2),CLChaFdSu(1:2,1:2),
     &                    CRChaFdSu(1:2,1:2),2d0/3d0,dEd_cha)
      dEd_cha=dEd_cha*convfac
      call EDM_dEf_chaone(MCha,MSd(1:2),CLChaFuSd,CRChaFuSd,
     &                    -1d0/3d0,dEu_cha)
      dEu_cha=dEu_cha*convfac
      call EDM_dEf_chaone(MCha,MSu(3:4),CLChaFdSu(1:2,3:4),
     &                    CRChaFdSu(1:2,3:4),2d0/3d0,dEs_cha)
      dEs_cha=dEs_cha*convfac
      
      call CEDM_dCq_chaone(MCha,MSu(1:2),CLChaFdSu(1:2,1:2),
     &                     CRChaFdSu(1:2,1:2),dCd_cha)
      call CEDM_dCq_chaone(MCha,MSd(1:2),CLChaFuSd,CRChaFuSd,dCu_cha)
      dCd_cha=dCd_cha*convfac
      dCu_cha=dCu_cha*convfac
      
!one-loop contributions of gluino loops to quark EDM
      call EDM_dEf_gluino(absM3,MSu(1:2),CLuFgSu,CRuFgSu,2d0/3d0,dEu_glu)
      call EDM_dEf_gluino(absM3,MSd(1:2),CLdFgSd,CRdFgSd,-1d0/3d0,dEd_glu)
      call EDM_dEf_gluino(absM3,MSd(3:4),CLsFgSs,CRsFgSs,-1d0/3d0,dEs_glu)
      dEu_glu=dEu_glu*convfac
      dEd_glu=dEd_glu*convfac
      dEs_glu=dEs_glu*convfac
      
!one-loop contributions of gluino loops to quark CEDM
      call CEDM_dCq_gluino(absM3,MSu(1:2),CLuFgSu,CRuFgSu,dCu_glu)
      call CEDM_dCq_gluino(absM3,MSd(1:2),CLdFgSd,CRdFgSd,dCd_glu)
      dCu_glu=dCu_glu*convfac
      dCd_glu=dCd_glu*convfac
      
      
! initialize VEGAS which is used for the evaluation of the loop functions
! appearing in the two-loop EDMs
      iprint=0
      ivegas(1)=1000
      ivegas(2)=5
      ivegas(3)=2000
      ivegas(4)=5
      
      call RSTART(12,34,56,78)

! calculate two-loop contributions to EDMs/CEDMs
      call EDM_dEf_gamH0(CSfdown,CPfdown,me,-1d0,dEe_gamH0)
      dEe_gamH0=dEe_gamH0*convfac
      
      call EDM_dEf_gamH0(CSfdown,CPfdown,md,-1d0/3d0,dEd_gamH0)
      dEd_gamH0=dEd_gamH0*convfac
      
      call EDM_dEf_gamH0(CSfdown,CPfdown,ms,-1d0/3d0,dEs_gamH0)
      dEs_gamH0=dEs_gamH0*convfac
      
      call EDM_dEf_gamH0(CSfup,CPfup,mu,2d0/3d0,dEu_gamH0)
      dEu_gamH0=dEu_gamH0*convfac
     
      call EDM_dEf_WHp(me,CSHpve,CPHpve,dEe_WHp)
      dEe_WHp=dEe_WHp*convfac
     
      call EDM_dEf_WHp(mu,CSHpud(1),CPHpud(1),dEd_WHp)
      dEd_WHp=dEd_WHp*convfac
      
      call EDM_dEf_WHp(mc,CSHpud(2),CPHpud(2),dEs_WHp)
      dEs_WHp=dEs_WHp*convfac
      
      call EDM_dEf_WW(me,dEe_WW)
      dEe_WW=dEe_WW*convfac
      
      call EDM_dEf_WW(md,dEd_WW)
      dEd_WW=dEd_WW*convfac
      
      call EDM_dEf_WW(ms,dEs_WW)
      dEs_WW=dEs_WW*convfac
      
      call EDM_dEf_WW(mu,dEu_WW)
      dEu_WW=dEu_WW*convfac
      
      call EDM_dEf_ZH(me,CSfdown,CPfdown,vZee,dEe_ZH)
      dEe_ZH=dEe_ZH*convfac
      
      call EDM_dEf_ZH(md,CSfdown,CPfdown,vZdd,dEd_ZH)
      dEd_ZH=dEd_ZH*convfac
      
      call EDM_dEf_ZH(ms,CSfdown,CPfdown,vZdd,dEs_ZH)
      dEs_ZH=dEs_ZH*convfac
      
      call EDM_dEf_ZH(mu,CSfup,CPfup,vZuu,dEu_ZH)
      dEu_ZH=dEu_ZH*convfac
      
      call CEDM_dCq_BZ(CSfdown,CPfdown,md,dCd_BZ)
      dCd_BZ=dCd_BZ*convfac
      
      call CEDM_dCq_BZ(CSfup,CPfup,mu,dCu_BZ)
      dCu_BZ=dCu_BZ*convfac
      
      ivegas(1)=4000
      ivegas(2)=5
      ivegas(3)=8000
      ivegas(4)=5
      
! Weinberg operator
      call EDM_dG_H(dG_H)
      dG_H=dG_H*convfac
      
      call EDM_dG_glu(dG_glu)
      dG_glu=dG_glu*convfac
      
      dEe_two=dEe_gamH0+dEe_WHp+dEe_WW+dEe_ZH
      dEd_two=dEd_gamH0+dEd_WHp+dEd_WW+dEd_ZH
      dEu_two=dEu_gamH0+dEu_WW+dEu_ZH
      dEs_two=dEs_gamH0+dEs_WHp+dEs_WW+dEs_ZH
      dEe_one=dEe_chi+dEe_cha
      dEd_one=dEd_chi+dEd_cha+dEd_glu
      dEs_one=dEs_chi+dEs_cha+dEs_glu
      dEu_one=dEu_chi+dEu_cha+dEu_glu
      dCd_one=dCd_chi+dCd_cha+dCd_glu
      dCu_one=dCu_chi+dCu_cha+dCu_glu
      dG_all=dG_H+dG_glu
      
      
      call dThallium(dEe_one,dEe_two,C4de,C4Se,C4ge,md,ms,v,dTl)
      
      call dn_CQM(dEd_one,dEu_one,dEd_two,dEu_two,dCd_one,
     &                   dCu_one,dCd_BZ,dCu_BZ,dG_all,dnCQM)
      
      call dn_QCDsum(dEd_one,dEu_one,dEd_two,dEu_two,dCd_one,
     &                   dCu_one,dCd_BZ,dCu_BZ,dG_all,C4bd,mb,dnQCDsum)
      
      call dn_PQM(dEd_one,dEd_two,dEu_one,dEu_two,dEs_one,dEs_two,dnPQM)
      
      call dEHg(dEe_one+dEe_two,dCu_one+dCu_BZ,dCd_one+dCd_BZ,dHg)
      
      
      open(unit=46,file=slhafile,status="old",position="append",action='write')
      write(46,51) 'BLOCK EDM'
      write(46,51) '# relevant observables, normalized to the experimental upper bound'
c MMM changed 24/3/2019
      write(46,53) 1,0,abs(dEe_one+dEe_two)/1.1d-29,
     .     'electron, normalized to d_exp=1.1E-29*e*cm'
c end MMM changed 24/3/2019      
      write(46,53) 2,0,abs(dTl(6))/9d-25,
     .             'Thallium, normalized to d_exp=9E-25*e*cm'
      write(46,53) 3,0,abs(dnCQM(6))/3d-26,
     .             'neutron - CQM approach, normalized to d_exp=3E-26*e*cm'
      write(46,53) 4,0,abs(dnQCDsum(7))/3d-26,
     .             'neutron - QCD sum rule approach, normalized to d_exp=3E-26*e*cm'
      write(46,53) 5,0,abs(dnPQM(6))/3d-26,
     .             'neutron - PQM approach, normalized to d_exp=3E-26*e*cm'
      write(46,53) 6,0,abs(dHg(1))/3.1d-29,
     .             'Mercury - d_Hg(I), normalized to d_exp=3.1E-29*e*cm'
      write(46,53) 7,0,abs(dHg(2))/3.1d-29,
     .             'Mercury - d_Hg(II), normalized to d_exp=3.1E-29*e*cm'
      write(46,53) 8,0,abs(dHg(3))/3.1d-29,
     .             'Mercury - d_Hg(III), normalized to d_exp=3.1E-29*e*cm'
      write(46,53) 9,0,abs(dHg(4))/3.1d-29,
     .             'Mercury - d_Hg(IV), normalized to d_exp=3.1E-29*e*cm'
      write(46,51) '#'
      if(EDMswitch.eq.2) then
      write(46,51) '# individual contributions to electron EDM in e*cm (absolute size)'
      write(46,53) 1,1,dEe_one+dEe_two,'electron, all contributions'
      write(46,53) 1,2,dEe_one, 'electron, one-loop contributions'
      write(46,53) 1,3,dEe_two, 'electron, two-loop contributions'
      write(46,53) 1,4,dEe_chi, 'electron, one-loop neutralino contributions'
      write(46,53) 1,5,dEe_cha, 'electron, one-loop chargino contributions'
      write(46,53) 1,6,dEe_gamH0, 'electron, two-loop gammaH contributions'
      write(46,53) 1,7,dEe_WW, 'electron, two-loop WW contributions'
      write(46,53) 1,8,dEe_WHp, 'electron, two-loop WHp contributions'
      write(46,53) 1,9,dEe_ZH, 'electron, two-loop ZH contributions'
      write(46,51) '#'
      write(46,51) '# individual contributions to Thallium EDM in e*cm (absolute size)'
      write(46,53) 2,1,dTl(6),'Thallium, all contributions'
      write(46,53) 2,2,dTl(1), 'Thallium, one-loop contributions'
      write(46,53) 2,3,dTl(2), 'Thallium, two-loop contributions'
      write(46,53) 2,4,dTl(3), 'Thallium, four-fermion operator contributions'
      write(46,51) '#'
      write(46,51) '# individual contributions to neutron EDM (CQM) in e*cm (absolute size)'
      write(46,53) 3,1,dnCQM(6),'dn_CQM, all contributions'
      write(46,53) 3,2,dnCQM(4), 'dn_CQM, one-loop contributions'
      write(46,53) 3,3,dnCQM(5), 'dn_CQM, two-loop contributions'
      write(46,53) 3,4,dnCQM(1), 'dn_CQM, EDM contributions'
      write(46,53) 3,5,dnCQM(2), 'dn_CQM, CEDM contributions'
      write(46,53) 3,6,dnCQM(3), 'dn_CQM, Weinbergoperator contributions'
      write(46,51) '#'
      write(46,51) '# individual contributions to neutron EDM (QCDsum) in e*cm (absolute size)'
      write(46,53) 4,1,dnQCDsum(7),'dn_QCDsum, all contributions'
      write(46,53) 4,2,dnQCDsum(5), 'dn_QCDsum, one-loop contributions'
      write(46,53) 4,3,dnQCDsum(6), 'dn_QCDsum, two-loop contributions'
      write(46,53) 4,4,dnQCDsum(1), 'dn_QCDsum, EDM contributions'
      write(46,53) 4,5,dnQCDsum(2), 'dn_QCDsum, CEDM contributions'
      write(46,53) 4,6,dnQCDsum(3), 'dn_QCDsum, Weinbergoperator contributions'
      write(46,53) 4,7,dnQCDsum(4), 'dn_QCDsum, four-fermion operator contributions'
      write(46,51) '#'
      write(46,51) '# individual contributions to neutron EDM (PQM) in e*cm (absolute size)'
      write(46,53) 5,1,dnPQM(6),'dn_PQM, all contributions'
      write(46,53) 5,2,dnPQM(4), 'dn_PQM, one-loop contributions'
      write(46,53) 5,3,dnPQM(5), 'dn_PQM, two-loop contributions'
      write(46,53) 5,4,dnPQM(1), 'dn_PQM, only down quark contributions'
      write(46,53) 5,5,dnPQM(2), 'dn_PQM, only up quark contributions'
      write(46,53) 5,6,dnPQM(3), 'dn_PQM, only strange quark contributions'
      write(46,51) '#'
      write(46,51) '# individual contributions to down-quark EDM in e*cm (absolute size)'
      write(46,53) 10,1,dEd_one+dEd_two,'down-quark, all contributions'
      write(46,53) 10,2,dEd_one, 'down-quark, one-loop contributions'
      write(46,53) 10,3,dEd_two, 'down-quark, two-loop contributions'
      write(46,53) 10,4,dEd_chi, 'down-quark, one-loop neutralino contributions'
      write(46,53) 10,5,dEd_cha, 'down-quark, one-loop chargino contributions'
      write(46,53) 10,6,dEd_glu, 'down-quark, one-loop gluino contributions'
      write(46,53) 10,7,dEd_gamH0, 'down-quark, two-loop gammaH contributions'
      write(46,53) 10,8,dEd_WW, 'down-quark, two-loop WW contributions'
      write(46,53) 10,9,dEd_WHp, 'down-quark, two-loop WHp contributions'
      write(46,53) 10,10,dEd_ZH, 'down-quark, two-loop ZH contributions'
      write(46,51) '#'
      write(46,51) '# individual contributions to down-quark CEDM in e*cm (absolute size)'
      write(46,53) 10,11,g3/e*(dCd_one+dCd_BZ),'down-quark, all contributions'
      write(46,53) 10,12,g3/e*dCd_one, 'down-quark, one-loop contributions'
      write(46,53) 10,13,g3/e*dCd_BZ, 'down-quark, two-loop contributions'
      write(46,53) 10,14,g3/e*dCd_chi, 'down-quark, one-loop neutralino contributions'
      write(46,53) 10,15,g3/e*dCd_cha, 'down-quark, one-loop chargino contributions'
      write(46,53) 10,16,g3/e*dCd_glu, 'down-quark, one-loop gluino contributions'
      write(46,53) 10,17,g3/e*dCd_BZ, 'down-quark, two-loop BZ contributions'
      write(46,51) '#'
      write(46,51) '# individual contributions to up-quark EDM in e*cm (absolute size)'
      write(46,53) 11,1,dEu_one+dEu_two,'up-quark, all contributions'
      write(46,53) 11,2,dEu_one, 'up-quark, one-loop contributions'
      write(46,53) 11,3,dEu_two, 'up-quark, two-loop contributions'
      write(46,53) 11,4,dEu_chi, 'up-quark, one-loop neutralino contributions'
      write(46,53) 11,5,dEu_cha, 'up-quark, one-loop chargino contributions'
      write(46,53) 11,6,dEu_glu, 'up-quark, one-loop gluino contributions'
      write(46,53) 11,7,dEu_gamH0, 'up-quark, two-loop gammaH contributions'
      write(46,53) 11,8,dEu_WW, 'up-quark, two-loop WW contributions'
      write(46,53) 11,9,dEu_ZH, 'up-quark, two-loop ZH contributions'
      write(46,51) '#'
      write(46,51) '# individual contributions to up-quark CEDM in e*cm (absolute size)'
      write(46,53) 11,10,g3/e*(dCu_one+dCu_BZ),'up-quark, all contributions'
      write(46,53) 11,11,g3/e*dCu_one, 'up-quark, one-loop contributions'
      write(46,53) 11,12,g3/e*dCu_BZ, 'up-quark, two-loop contributions'
      write(46,53) 11,13,g3/e*dCu_chi, 'up-quark, one-loop neutralino contributions'
      write(46,53) 11,14,g3/e*dCu_cha, 'up-quark, one-loop chargino contributions'
      write(46,53) 11,15,g3/e*dCu_glu, 'up-quark, one-loop gluino contributions'
      write(46,53) 11,16,g3/e*dCu_BZ, 'up-quark, two-loop BZ contributions'
      end if
      close(46)
     
!       write(*,*) 'filename',folder,countvalid,phase,filename
!       write(filename,'(A7,A14)') folder,'/dThallium.dat'
!       write(*,*) filename
!       write(*,*) 'filename',filename
!       if(countvalid.eq.1) then
!       open(unit=46,file=filename,status="unknown",action='write')
!       write(46,*) '#  Thallium'
!       write(46,*) '#  pnum phase   1loop','             2loop','                   C4'
!      &             ,'                        all'
!       else
!       open(unit=46,file=filename,status="old",position="append",action='write')
!       end if
!       write(46,*) countvalid,phase,dTl(1),dTl(2),dTl(3),dTl(6)
!       close(46)
!       
!      
!       write(filename,'(A7,A8)') folder,'/dEe.dat'
!       write(*,*) 'filename',filename
!       if(countvalid.eq.1) then
!       open(unit=47,file=filename,status="unknown",action='write')
!       write(47,*) '#  electron'
!       write(47,*) '#  pnum phase   1loop','             2loop','                        all'
!       else
!       open(unit=47,file=filename,status="old",position="append",action='write')
!       end if
!       write(*,*) phase
!       write(*,*) dEe_one,dEe_two,dEe_one+dEe_two
!       dEe_all=dEe_two+dEe_one
!       write(47,*) countvalid,phase,dEe_one,dEe_two,dEe_all,
!      &            dEe_chi,dEe_cha,
!      &            dEe_gamH0,dEe_WW,dEe_WHp,dEe_ZH
!       close(47)
!       
!       
!       write(filename,'(A7,A8)') folder,'/dEd.dat'
!       write(*,*) 'filename',filename
!       if(countvalid.eq.1) then
!       open(unit=47,file=filename,status="unknown",action='write')
!       write(47,*) '#  electron'
!       write(47,*) '#  pnum phase   1loop','             2loop','                        all'
!       else
!       open(unit=47,file=filename,status="old",position="append",action='write')
!       end if
!       write(*,*) phase
!       write(*,*) dEe_one,dEe_two,dEe_one+dEe_two
!       dEe_all=dEe_two+dEe_one
!       write(47,*) countvalid,phase,dEd_one,dEd_two,dEd_one+dEd_two,
!      &            dEd_chi,dEd_cha,dEd_glu,
!      &            dEd_gamH0,dEd_WW,dEd_WHp,dEd_ZH,
!      &            dCd_chi,dCd_cha,dCd_glu,dCd_BZ
!       close(47)
!       
!       
!       write(filename,'(A7,A8)') folder,'/dHg.dat'
!       write(*,*) 'filename',filename
!       if(countvalid.eq.1) then
!       open(unit=47,file=filename,status="unknown",action='write')
!       write(47,*) '#  dHg'
!       write(47,*) '#  pnum phase   ','dHg'
!       else
!       open(unit=47,file=filename,status="old",position="append",action='write')
!       end if
!       write(47,*) countvalid,phase,dHg(1),dHg(2),dHg(3),dHg(4)
!       close(47)
!       
!       write(filename,'(A7,A8)') folder,'/dEu.dat'
!       write(*,*) 'filename',filename
!       if(countvalid.eq.1) then
!       open(unit=47,file=filename,status="unknown",action='write')
!       write(47,*) '#  electron'
!       write(47,*) '#  pnum phase   1loop','             2loop','                        all'
!       else
!       open(unit=47,file=filename,status="old",position="append",action='write')
!       end if
!       write(*,*) phase
!       write(*,*) dEe_one,dEe_two,dEe_one+dEe_two
!       dEe_all=dEe_two+dEe_one
!       write(47,*) countvalid,phase,dEu_one,dEu_two,dEu_one+dEu_two,
!      &            dEu_chi,dEu_cha,dEu_glu,
!      &            dEu_gamH0,dEu_WW,0d0,dEu_ZH,
!      &            dCu_chi,dCu_cha,dCu_glu,dCu_BZ
!       close(47)
!       
!       
!       write(filename,'(A7,A10)') folder,'/dnCQM.dat'
!       write(*,*) 'filename',filename
!       if(countvalid.eq.1) then
!       open(unit=46,file=filename,status="unknown",action='write')
!       write(46,*) '#  neutron CQM'
!       write(46,*) '#  pnum phase   EDMS','             CEDMS','                       Weinberg',
!      & '        1loop','        2loop','          all'
!       else
!       open(unit=46,file=filename,status="old",position="append",action='write')
!       end if
!       write(46,*) countvalid,phase,dnCQM
!       close(46)
!       
!       write(filename,'(A7,A13)') folder,'/dnQCDsum.dat'
!       write(*,*) 'filename',filename
!       if(countvalid.eq.1) then
!       open(unit=46,file=filename,status="unknown",action='write')
!       write(46,*) '#  neutron CQM'
!       write(46,*) '#  pnum phase   EDMS','             CEDMS','                       Weinberg',
!      & '           C4','        1loop','        2loop','          all'
!       else
!       open(unit=46,file=filename,status="old",position="append",action='write')
!       end if
!       write(46,*) countvalid,phase,dnQCDsum
!       close(46)
      
 51   format(A)
 53   format(1x,I2,1x,I2,3x,1P,E16.8,0P,3x,'#',1x,A)
      return
      end
     
      
      
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccc  one-loop neutralino contribution to EDMs                     cccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine EDM_dEf_chione(MChi,MSf,CLChiFSf,CRChiFSf,Qf,dEf_chi)
      implicit none
      
      double precision MChi(5),MSf(2),Qf
      double complex CLChiFSf(5,2),CRChiFSf(5,2)
      double precision dEf_chi
      double precision BFUNC_EDM
      integer i,j
      double precision pi
      parameter (pi = 2d0*DAsin(1d0))
     
      dEf_chi=0d0
      do i=1,5
      do j=1,2
      dEf_chi=dEf_chi+Qf*MChi(i)/MSf(j)**2*
     &        AIMAG(CONJG(CRChiFSf(i,j))*CLChiFSf(i,j))*
     &        BFUNC_EDM(MChi(i)**2/MSf(j)**2)/16d0/pi**2
      end do
      end do
      
      return
      end
      
      
      
      subroutine CEDM_dCq_chione(MChi,MSq,CLChiFqSq,CRChiFqSq,dCq_chi)
      implicit none
      
      double precision MChi(5),MSq(2)
      double complex CLChiFqSq(5,2),CRChiFqSq(5,2)
      double precision dCq_chi
      double precision BFUNC_EDM
      integer i,j
      double precision pi
      parameter (pi = 2d0*DAsin(1d0))
      
      dCq_chi=0d0
      do i=1,5
      do j=1,2
      dCq_chi=dCq_chi+MChi(i)/MSq(j)**2*
     &        AIMAG(CONJG(CRChiFqSq(i,j))*CLChiFqSq(i,j))*
     &        BFUNC_EDM(MChi(i)**2/MSq(j)**2)/16d0/pi**2
      end do
      end do
      
      return
      end
      
      
      
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccc  one-loop chargino contribution to EDMs                     cccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine EDM_dEf_chaone(MCha,MSf,CLChaFSf,CRChaFSf,Qf,dEf_cha)
      implicit none
      
      double precision MCha(2),MSf(2),Qf,Qx
      double complex CLChaFSf(2,2),CRChaFSf(2,2)
      double precision dEf_cha,temp
      double precision AFUNC_EDM,BFUNC_EDM
      integer i,j
      double precision pi
      parameter (pi = 2d0*DAsin(1d0))
     
      if(Qf.ge.0d0) then
      Qx=-1d0
      else
      Qx=1d0
      end if
      
      dEf_cha=0d0
      do i=1,2
      do j=1,2
       if(MSf(j).eq.0d0) then
       temp=0d0
       else
       temp=MCha(i)/MSf(j)**2*
     &        AIMAG(CONJG(CRChaFSf(i,j))*CLChaFSf(i,j))*
     &        (Qf*BFUNC_EDM(MCha(i)**2/MSf(j)**2)+
     &         Qx*AFUNC_EDM(MCha(i)**2/MSf(j)**2))/16d0/pi**2
       end if
       dEf_cha=dEf_cha+temp
      end do
      end do
      
      return
      end
      
      
      
      subroutine CEDM_dCq_chaone(MCha,MSq,CLChaFqSq,CRChaFqSq,dCq_cha)
      implicit none
      
      double precision MCha(2),MSq(2)
      double complex CLChaFqSq(2,2),CRChaFqSq(2,2)
      double precision dCq_cha
      double precision BFUNC_EDM
      integer i,j
      double precision pi
      parameter (pi = 2d0*DAsin(1d0))
      
      dCq_cha=0d0
      do i=1,2
      do j=1,2
      dCq_cha=dCq_cha+MCha(i)/MSq(j)**2*
     &        AIMAG(CONJG(CRChaFqSq(i,j))*CLChaFqSq(i,j))*
     &        BFUNC_EDM(MCha(i)**2/MSq(j)**2)/16d0/pi**2
      end do
      end do
      
      return
      end
      
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccc  one-loop gluino contributions                            ccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine EDM_dEf_gluino(absM3,MSq,CLqFgSq,CRqFgSq,Qq,dEf_glu)
      implicit none
      
      double precision absM3,Msq(2),Qq
      double complex CLqFgSq(2),CRqFgSq(2)
      double precision dEf_glu
      double precision BFUNC_EDM
      integer i
      double precision pi
      parameter (pi = 2d0*DAsin(1d0))
      
      dEf_glu=0d0
      do i=1,2
      dEf_glu=dEf_glu+absM3/MSq(i)**2*
     &        AIMAG(CONJG(CRqFgSq(i))*CLqFgSq(i))*
     &        Qq*BFUNC_EDM(absM3**2/MSq(i)**2)/3d0/pi**2
      end do
      
      return
      end
      
      
      subroutine CEDM_dCq_gluino(absM3,MSq,CLqFgSq,CRqFgSq,dCq_glu)
      implicit none
      
      double precision absM3,Msq(2)
      double complex CLqFgSq(2),CRqFgSq(2)
      double precision dCq_glu
      double precision CFUNC_EDM
      integer i
      double precision pi
      parameter (pi = 2d0*DAsin(1d0))
      
      dCq_glu=0d0
      do i=1,2
      dCq_glu=dCq_glu-absM3/MSq(i)**2*
     &        AIMAG(CONJG(CRqFgSq(i))*CLqFgSq(i))*
     &        CFUNC_EDM(absM3**2/MSq(i)**2)/8d0/pi**2
      end do
      
      return
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      Barr-Zee-type contributions                                    c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      
      subroutine EDM_dEf_gamH0(CSf,CPf,mf,Qf,dEf_gamH0)
      implicit none
      
      double precision CSf(5),CPf(5),mf,Qf
      double precision dEf_gamH0
      
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double complex CLChiFeSe(5,2),CRChiFeSe(5,2),CLChiFdSd(5,4),
     &               CRChiFdSd(5,4),CLChiFuSu(5,2),CRChiFuSu(5,2),
     &               ChStauStau(5,2,2),ChSbSb(5,2,2),ChStSt(5,2,2),
     &               CShChaCha(5,2,2),CPhChaCha(5,2,2)
      double precision CSfdown(5),CPfdown(5),CSfup(5),CPfup(5)
      double complex  CPHpChiCha(5,2),CSHpChiCha(5,2),CLWChiCha(5,2),
     &                 CRWChiCha(5,2),CPHpud(2),CSHpud(2),CSHpve,CPHpve 
      double complex CLChaFdSu(2,4),CRChaFdSu(2,4),CLChaFuSd(2,2),
     &               CRChaFuSd(2,2),CLChaFeSv(2),CRChaFeSv(2),
     &               CLdFgSd(2),CRdFgSd(2),CRuFgSu(2),CLuFgSu(2),
     &               CLbFgSb(2),CRbFgSb(2),CRtFgSt(2),CLtFgSt(2),
     &               CLsFgSs(2),CRsFgSs(2)
      
      double precision Qq(2),msq(2,2),mq(2)
      double complex Chsqsq(2,5,2,2),CSq(2,5),CPq(2,5)
      double precision x(5,2),y(5)
      
      double precision FUNC_EDM,fFUNC_EDM,gFUNC_EDM
      
      double complex part1,part2,part3,part4,part5
      double precision sw
      integer q,h,i,j
      double precision pi
      parameter (pi = 2d0*Asin(1d0))
      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common/ couplingsEDM / CLChiFeSe,CRChiFeSe,CLChiFdSd,CRChiFdSd,
     &                       CLChiFuSu,CRChiFuSu,ChStauStau,ChSbSb,
     &                       ChStSt,CShChaCha,CPhChaCha,CSHpChiCha,
     &                       CPHpChiCha,CLWChiCha,CRWChiCha,
     &                       CSfdown,CPfdown,CSfup,CPfup,
     &                       CPHpud,CSHpud,CSHpve,CPHpve,
     &                       CLChaFdSu,CRChaFdSu,CLChaFuSd,CRChaFuSd,
     &                       CLChaFeSv,CRChaFeSv,CLdFgSd,CRdFgSd,
     &                       CRuFgSu,CLuFgSu,CLbFgSb,CRbFgSb,
     &                       CRtFgSt,CLtFgSt,CLsFgSs,CRsFgSs
      
      
      Qq(1)=2d0/3d0
      Qq(2)=-1d0/3d0
      mq(1)=mt
      mq(2)=mb
      
      do i=1,2
      msq(1,i)=MSu(i+4)
      msq(2,i)=MSd(i+4)
      end do
     
      do h=1,5
      do i=1,2
      do j=1,2
      Chsqsq(1,h,i,j)=ChStSt(h,i,j)
      Chsqsq(2,h,i,j)=ChSbSb(h,i,j)
      end do
      end do
      end do
      
      do h=1,5
      CSq(1,h)=CSfup(h)
      CSq(2,h)=CSfdown(h)
      CPq(1,h)=CPfup(h)
      CPq(2,h)=CPfdown(h)
      end do
      
      part1=0d0
      do q=1,2
        do h=1,5
          do i=1,2
          x(h,i)=msq(q,i)**2/Mh(h)**2
          part1=part1+3d0*alpha*Qq(q)**2*mf*CPf(h)*Chsqsq(q,h,i,i)*
     &          FUNC_EDM(x(h,i))/32d0/pi**3/Mh(h)**2
          end do
        end do
      end do
      
      sw=Sqrt(1-MW**2/MZ**2)
      part2=0d0
      do q=1,2
      do h=1,5
      x(h,q)=mq(q)**2/Mh(h)**2
      part2=part2+3d0*alpha**2*Qq(q)**2*mf*
     &     (CPf(h)*CSq(q,h)*fFUNC_EDM(x(h,q)) +
     &      CSf(h)*CPq(q,h)*gFUNC_EDM(x(h,q)))/
     &      8d0/pi**2/sw**2/Mw**2
      end do
      end do
      
      part3=0d0
      do h=1,2
      do i=1,2
      x(h,i)=MSe(i+4)**2/Mh(h)**2
      part3=part3+alpha*mf*CPf(h)*ChStauStau(h,i,i)*
     &      FUNC_EDM(x(h,i))/32d0/pi**3/Mh(h)**2
      end do
      end do
      
      part4=0d0
      do h=1,5
      y(h)=mtau**2/Mh(h)**2
      part4=part4+alpha**2*mf*(CPf(h)*CSfdown(h)*fFUNC_EDM(y(h))+
     &      CSf(h)*CPfdown(h)*gFUNC_EDM(y(h)))/
     &      8d0/pi**2/sw**2/Mw**2
      end do
      
      part5=0d0
      do h=1,5
      do i=1,2
      x(h,i)=Mcha(i)**2/Mh(h)**2
      part5=part5+alpha**2*mf*  
     &     (CPf(h)*CShChaCha(h,i,i)*fFUNC_EDM(x(h,i))+
     &      CSf(h)*CPhChaCha(h,i,i)*gFUNC_EDM(x(h,i)))/
     &      4d0/sqrt(2d0)/pi**2/sw**2/Mw/Mcha(i)
      end do
      end do
     
      dEf_gamH0=-Qf*(part1+part2+part3+part4+part5)
      
      return
      end
      
      
      
      subroutine EDM_dEf_WHp(mf,gSHpff,gPHpff,dEf_WHp)
      implicit none
      
      double precision mf
      double complex gSHpff,gPHpff
      double precision dEf_WHp
      
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      
      double complex CLChiFeSe(5,2),CRChiFeSe(5,2),CLChiFdSd(5,4),
     &               CRChiFdSd(5,4),CLChiFuSu(5,2),CRChiFuSu(5,2),
     &               ChStauStau(5,2,2),ChSbSb(5,2,2),ChStSt(5,2,2),
     &               CShChaCha(5,2,2),CPhChaCha(5,2,2)
      double precision CSfdown(5),CPfdown(5),CSfup(5),CPfup(5)
      double complex  CPHpChiCha(5,2),CSHpChiCha(5,2),CLWChiCha(5,2),
     &                 CRWChiCha(5,2),CPHpud(2),CSHpud(2),CSHpve,CPHpve 
      double complex CLChaFdSu(2,4),CRChaFdSu(2,4),CLChaFuSd(2,2),
     &               CRChaFuSd(2,2),CLChaFeSv(2),CRChaFeSv(2),
     &               CLdFgSd(2),CRdFgSd(2),CRuFgSu(2),CLuFgSu(2),
     &               CLbFgSb(2),CRbFgSb(2),CRtFgSt(2),CLtFgSt(2),
     &               CLsFgSs(2),CRsFgSs(2)
     
      double precision sw
      double precision j1,j2,j3,a,b,c,d
      double complex GpRL,GmRL,GpLR,GmLR
      
      double precision JFUNC1_EDM
      
      integer i,j

      double precision pi
      parameter (pi = 2d0*Asin(1d0))
      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common/ couplingsEDM / CLChiFeSe,CRChiFeSe,CLChiFdSd,CRChiFdSd,
     &                       CLChiFuSu,CRChiFuSu,ChStauStau,ChSbSb,
     &                       ChStSt,CShChaCha,CPhChaCha,CSHpChiCha,
     &                       CPHpChiCha,CLWChiCha,CRWChiCha,
     &                       CSfdown,CPfdown,CSfup,CPfup,
     &                       CPHpud,CSHpud,CSHpve,CPHpve,
     &                       CLChaFdSu,CRChaFdSu,CLChaFuSd,CRChaFuSd,
     &                       CLChaFeSv,CRChaFeSv,CLdFgSd,CRdFgSd,
     &                       CRuFgSu,CLuFgSu,CLbFgSb,CRbFgSb,
     &                       CRtFgSt,CLtFgSt,CLsFgSs,CRsFgSs
      
      sw=Sqrt(1-MW**2/MZ**2)
    
      dEf_WHp=0d0
      do i=1,5
      do j=1,2
      j1=Mw**2/MHpm**2
      j2=MCha(j)**2/MHpm**2
      j3=MChi(i)**2/MHpm**2
      GpRL=CONJG(CSHpChiCha(i,j))*(CRWChiCha(i,j)+CLWChiCha(i,j))+
     &     (0d0,1d0)*CONJG(CPHpChiCha(i,j))*
     &     (CRWChiCha(i,j)-CLWChiCha(i,j)) 
      GmRL=CONJG(CSHpChiCha(i,j))*(CRWChiCha(i,j)-CLWChiCha(i,j))+
     &     (0d0,1d0)*CONJG(CPHpChiCha(i,j))*
     &     (CRWChiCha(i,j)+CLWChiCha(i,j))
      GpLR=CONJG(CSHpChiCha(i,j))*(CLWChiCha(i,j)+CRWChiCha(i,j))+
     &     (0d0,1d0)*CONJG(CPHpChiCha(i,j))*
     &     (CLWChiCha(i,j)-CRWChiCha(i,j)) 
      GmLR=CONJG(CSHpChiCha(i,j))*(CLWChiCha(i,j)-CRWChiCha(i,j))+
     &     (0d0,1d0)*CONJG(CPHpChiCha(i,j))*
     &     (CLWChiCha(i,j)+CRWChiCha(i,j)) 
      a=AIMAG((gSHpff+(0d0,1d0)*gPHpff)*GpRL*MCha(j))
      b=AIMAG((gSHpff+(0d0,1d0)*gPHpff)*GpLR*MChi(i))
      c=AIMAG((gSHpff+(0d0,1d0)*gPHpff)*GmRL*MCha(j))
      d=AIMAG((gSHpff+(0d0,1d0)*gPHpff)*GmLR*MChi(i))
      
      dEf_WHp=dEf_WHp+
     &        alpha**2*mf/(64d0*pi**2*sw**4*Mw*MHpm**2)*
     &        JFUNC1_EDM(j1,j2,j3,a,b,c,d)
      end do
      end do
      
      
      
      return
      end
      
      
      
      
      subroutine EDM_dEf_WW(mf,dEf_WW)
      implicit none
      
      double precision mf
      double precision dEf_WW
      
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      
      double complex CLChiFeSe(5,2),CRChiFeSe(5,2),CLChiFdSd(5,4),
     &               CRChiFdSd(5,4),CLChiFuSu(5,2),CRChiFuSu(5,2),
     &               ChStauStau(5,2,2),ChSbSb(5,2,2),ChStSt(5,2,2),
     &               CShChaCha(5,2,2),CPhChaCha(5,2,2)
      double precision CSfdown(5),CPfdown(5),CSfup(5),CPfup(5)
      double complex  CPHpChiCha(5,2),CSHpChiCha(5,2),CLWChiCha(5,2),
     &                 CRWChiCha(5,2),CPHpud(2),CSHpud(2),CSHpve,CPHpve 
      double complex CLChaFdSu(2,4),CRChaFdSu(2,4),CLChaFuSd(2,2),
     &               CRChaFuSd(2,2),CLChaFeSv(2),CRChaFeSv(2),
     &               CLdFgSd(2),CRdFgSd(2),CRuFgSu(2),CLuFgSu(2),
     &               CLbFgSb(2),CRbFgSb(2),CRtFgSt(2),CLtFgSt(2),
     &               CLsFgSs(2),CRsFgSs(2)
     
      double precision sw,a,b
      
      double precision fWWFUNC_EDM
      
      integer i,j

      double precision pi
      parameter (pi = 2d0*Asin(1d0))
      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common/ couplingsEDM / CLChiFeSe,CRChiFeSe,CLChiFdSd,CRChiFdSd,
     &                       CLChiFuSu,CRChiFuSu,ChStauStau,ChSbSb,
     &                       ChStSt,CShChaCha,CPhChaCha,CSHpChiCha,
     &                       CPHpChiCha,CLWChiCha,CRWChiCha,
     &                       CSfdown,CPfdown,CSfup,CPfup,
     &                       CPHpud,CSHpud,CSHpve,CPHpve,
     &                       CLChaFdSu,CRChaFdSu,CLChaFuSd,CRChaFuSd,
     &                       CLChaFeSv,CRChaFeSv,CLdFgSd,CRdFgSd,
     &                       CRuFgSu,CLuFgSu,CLbFgSb,CRbFgSb,
     &                       CRtFgSt,CLtFgSt,CLsFgSs,CRsFgSs
      
      sw=Sqrt(1-MW**2/MZ**2)
    
      dEf_WW=0d0
      do i=1,5
      do j=1,2
      a=MChi(i)**2/Mw**2
      b=MCha(j)**2/Mw**2
      dEf_WW=dEf_WW+
     &     alpha**2*mf*MChi(i)*MCha(j)/(32d0*pi**2*sw**4*Mw**4)*
     &     AImAG(CLWChiCha(i,j)*CONJG(CRWChiCha(i,j)))*fWWFUNC_EDM(a,b)
      end do
      end do
      
      
      
      return
      end
      
      
      
      
      
      
      
      subroutine EDM_dEf_ZH(mf,CSf,CPf,vZff,dEf_ZH)
      implicit none
      
      double precision mf,CSf(5),CPf(5)
      double complex vZff
      double precision dEf_ZH
      
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      double complex CLChiFeSe(5,2),CRChiFeSe(5,2),CLChiFdSd(5,4),
     &               CRChiFdSd(5,4),CLChiFuSu(5,2),CRChiFuSu(5,2),
     &               ChStauStau(5,2,2),ChSbSb(5,2,2),ChStSt(5,2,2),
     &               CShChaCha(5,2,2),CPhChaCha(5,2,2)
      double precision CSfdown(5),CPfdown(5),CSfup(5),CPfup(5)
      double complex  CPHpChiCha(5,2),CSHpChiCha(5,2),CLWChiCha(5,2),
     &                 CRWChiCha(5,2),CPHpud(2),CSHpud(2),CSHpve,CPHpve 
      double complex vZuu,aZuu,vZdd,aZdd,vZee,aZee,vZchacha(2,2),
     &               aZchacha(2,2)
      double complex CLChaFdSu(2,4),CRChaFdSu(2,4),CLChaFuSd(2,2),
     &               CRChaFuSd(2,2),CLChaFeSv(2),CRChaFeSv(2),
     &               CLdFgSd(2),CRdFgSd(2),CRuFgSu(2),CLuFgSu(2),
     &               CLbFgSb(2),CRbFgSb(2),CRtFgSt(2),CLtFgSt(2),
     &               CLsFgSs(2),CRsFgSs(2)
     
      double precision sw,cw,Qq(2),mq(2),CSq(2,5),CPq(2,5),a,b,c
      double complex vZqq(2)
      
      double precision JFUNC2_EDM,JFUNC3_EDM,JFUNC4_EDM,JFUNC5_EDM
      
      integer i,j,q,k
      
      double complex part1,part2,part3

      double precision pi
      parameter (pi = 2d0*Asin(1d0))
      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common/ couplingsEDM / CLChiFeSe,CRChiFeSe,CLChiFdSd,CRChiFdSd,
     &                       CLChiFuSu,CRChiFuSu,ChStauStau,ChSbSb,
     &                       ChStSt,CShChaCha,CPhChaCha,CSHpChiCha,
     &                       CPHpChiCha,CLWChiCha,CRWChiCha,
     &                       CSfdown,CPfdown,CSfup,CPfup,
     &                       CPHpud,CSHpud,CSHpve,CPHpve,
     &                       CLChaFdSu,CRChaFdSu,CLChaFuSd,CRChaFuSd,
     &                       CLChaFeSv,CRChaFeSv,CLdFgSd,CRdFgSd,
     &                       CRuFgSu,CLuFgSu,CLbFgSb,CRbFgSb,
     &                       CRtFgSt,CLtFgSt,CLsFgSs,CRsFgSs
      common/ couplingsEDM2/ vZuu,aZuu,vZdd,aZdd,vZee,aZee,vZchacha,
     &                       aZchacha 
      
      sw=Sqrt(1-MW**2/MZ**2)
      cw=Mw**2/Mz**2
    
      Qq(1)=2d0/3d0
      Qq(2)=-1d0/3d0
      mq(1)=mt
      mq(2)=mb
      vZqq(1)=vZuu
      vZqq(2)=vZdd
      do i=1,5
      CSq(1,i)=CSfup(i)
      Csq(2,i)=CSfdown(i)
      CPq(1,i)=CPfup(i)
      CPq(2,i)=CPfdown(i)
      end do
      
      part1=0d0
      do q=1,2
      do i=1,5
      a=Mz**2/Mh(i)**2
      b=mq(q)**2/Mh(i)**2
      part1=part1+3d0*Qq(q)*alpha**2*vZff*mf*mq(q)**2*vZqq(q)/
     &     (32d0*pi**2*cw**2*sw**4*Mw**2*Mh(i)**2)*
     &     (CSf(i)*CPq(q,i)*JFUNC2_EDM(a,b)+
     &      CPf(i)*CSq(q,i)*JFUNC3_EDM(a,b))
      end do
      end do
      
      
      part2=0d0
      do i=1,5
      a=Mz**2/Mh(i)**2
      b=mtau**2/Mh(i)**2
      part2=part2-alpha**2*vZff*mf*mtau**2*vZee/
     &     (32d0*pi**2*cw**2*sw**4*Mw**2*Mh(i)**2)*
     &     (CSf(i)*CPfdown(i)*JFUNC2_EDM(a,b)+
     &      CPf(i)*CSfdown(i)*JFUNC3_EDM(a,b))
      end do
      
      part3=0d0
      do i=1,2
      do j=1,2
      do k=1,5
      a=Mz**2/Mh(k)**2
      b=MCha(i)**2/Mh(k)**2
      c=MCha(j)**2/Mh(k)**2
      part3=part3-alpha**2*vZff*mf*MCha(j)/
     &     (16d0*sqrt(2d0)*pi**2*cw**2*sw**4*Mw*Mh(k)**2)*
     &     (CSf(k)*AIMAG(aZchacha(j,i)*CShChaCha(k,i,j)+
     &     (0d0,1d0)*vZchacha(j,i)*CPhChaCha(k,i,j))*JFUNC4_EDM(a,b,c)+
     &     CPf(k)*AIMAG((0d0,1d0)*vZchacha(j,i)*CShChaCha(k,i,j)-
     &     aZchacha(j,i)*CPhChaCha(k,i,j))*JFUNC5_EDM(a,b,c))
      end do
      end do
      end do
      
      dEf_ZH=part1+part2+part3
      
      return
      end
      
      
      
      
      
      subroutine CEDM_dCq_BZ(CSqext,CPqext,mqext,dCq_BZ)
      implicit none
      
      double precision CSqext(5),CPqext(5),mqext
      double precision dCq_BZ
      
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double complex CLChiFeSe(5,2),CRChiFeSe(5,2),CLChiFdSd(5,4),
     &               CRChiFdSd(5,4),CLChiFuSu(5,2),CRChiFuSu(5,2),
     &               ChStauStau(5,2,2),ChSbSb(5,2,2),ChStSt(5,2,2),
     &               CShChaCha(5,2,2),CPhChaCha(5,2,2)
      double precision CSfdown(5),CPfdown(5),CSfup(5),CPfup(5)
      double complex  CPHpChiCha(5,2),CSHpChiCha(5,2),CLWChiCha(5,2),
     &                 CRWChiCha(5,2),CPHpud(2),CSHpud(2),CSHpve,CPHpve 
      double complex CLChaFdSu(2,4),CRChaFdSu(2,4),CLChaFuSd(2,2),
     &               CRChaFuSd(2,2),CLChaFeSv(2),CRChaFeSv(2),
     &               CLdFgSd(2),CRdFgSd(2),CRuFgSu(2),CLuFgSu(2),
     &               CLbFgSb(2),CRbFgSb(2),CRtFgSt(2),CLtFgSt(2),
     &               CLsFgSs(2),CRsFgSs(2)
      
      double precision msq(2,2),mq(2)
      double complex Chsqsq(2,5,2,2),CSq(2,5),CPq(2,5)
      double precision x(5,2),y(5)
      
      double precision FUNC_EDM,fFUNC_EDM,gFUNC_EDM
     
      double precision sw,a,b
      double complex part1,part2
      integer q,h,i,j
      double precision pi
      parameter (pi = 2d0*Asin(1d0))
      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common/ couplingsEDM / CLChiFeSe,CRChiFeSe,CLChiFdSd,CRChiFdSd,
     &                       CLChiFuSu,CRChiFuSu,ChStauStau,ChSbSb,
     &                       ChStSt,CShChaCha,CPhChaCha,CSHpChiCha,
     &                       CPHpChiCha,CLWChiCha,CRWChiCha,
     &                       CSfdown,CPfdown,CSfup,CPfup,
     &                       CPHpud,CSHpud,CSHpve,CPHpve,
     &                       CLChaFdSu,CRChaFdSu,CLChaFuSd,CRChaFuSd,
     &                       CLChaFeSv,CRChaFeSv,CLdFgSd,CRdFgSd,
     &                       CRuFgSu,CLuFgSu,CLbFgSb,CRbFgSb,
     &                       CRtFgSt,CLtFgSt,CLsFgSs,CRsFgSs
      

      mq(1)=mt
      mq(2)=mb
      
      do i=1,2
      msq(1,i)=MSu(i+4)
      msq(2,i)=MSd(i+4)
      end do
     
      do h=1,5
      do i=1,2
      do j=1,2
      Chsqsq(1,h,i,j)=ChStSt(h,i,j)
      Chsqsq(2,h,i,j)=ChSbSb(h,i,j)
      end do
      end do
      end do
      
      do h=1,5
      CSq(1,h)=CSfup(h)
      CSq(2,h)=CSfdown(h)
      CPq(1,h)=CPfup(h)
      CPq(2,h)=CPfdown(h)
      end do
      
      sw=Sqrt(1-MW**2/MZ**2)
      
      
      part1=0d0
      part2=0d0
      do q=1,2
      do h=1,5
      b=mq(q)**2/Mh(h)**2
      part2=part2-g3**2*alpha*mqext/(64d0*pi**3*sw**2*Mw**2)*
     &      (CPqext(h)*CSq(q,h)*fFUNC_EDM(b)+
     &       CSqext(h)*CPq(q,h)*gFUNC_EDM(b))
      do j=1,2
      a=msq(q,j)**2/Mh(h)**2
      part1=part1-g3**2*mqext*CPqext(h)*Chsqsq(q,h,j,j)*FUNC_EDM(a)/
     &      (256d0*pi**4*Mh(h)**2)
      end do
      end do
      end do

      dCq_BZ=part1+part2
      
      return
      end
      
      
      
      subroutine EDM_dG_H(dG_H)
      implicit none
     
      double precision dG_H
      
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double complex CLChiFeSe(5,2),CRChiFeSe(5,2),CLChiFdSd(5,4),
     &               CRChiFdSd(5,4),CLChiFuSu(5,2),CRChiFuSu(5,2),
     &               ChStauStau(5,2,2),ChSbSb(5,2,2),ChStSt(5,2,2),
     &               CShChaCha(5,2,2),CPhChaCha(5,2,2)
      double precision CSfdown(5),CPfdown(5),CSfup(5),CPfup(5)
      double complex  CPHpChiCha(5,2),CSHpChiCha(5,2),CLWChiCha(5,2),
     &                 CRWChiCha(5,2),CPHpud(2),CSHpud(2),CSHpve,CPHpve 
      double complex CLChaFdSu(2,4),CRChaFdSu(2,4),CLChaFuSd(2,2),
     &               CRChaFuSd(2,2),CLChaFeSv(2),CRChaFeSv(2),
     &               CLdFgSd(2),CRdFgSd(2),CRuFgSu(2),CLuFgSu(2),
     &               CLbFgSb(2),CRbFgSb(2),CRtFgSt(2),CLtFgSt(2),
     &               CLsFgSs(2),CRsFgSs(2)
      
      double precision mq(2)
      double complex CSq(2,5),CPq(2,5)
      double precision hFUNC_EDM,a
  
      integer q,h
      double precision pi
      parameter (pi = 2d0*Asin(1d0))
      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common/ couplingsEDM / CLChiFeSe,CRChiFeSe,CLChiFdSd,CRChiFdSd,
     &                       CLChiFuSu,CRChiFuSu,ChStauStau,ChSbSb,
     &                       ChStSt,CShChaCha,CPhChaCha,CSHpChiCha,
     &                       CPHpChiCha,CLWChiCha,CRWChiCha,
     &                       CSfdown,CPfdown,CSfup,CPfup,
     &                       CPHpud,CSHpud,CSHpve,CPHpve,
     &                       CLChaFdSu,CRChaFdSu,CLChaFuSd,CRChaFuSd,
     &                       CLChaFeSv,CRChaFeSv,CLdFgSd,CRdFgSd,
     &                       CRuFgSu,CLuFgSu,CLbFgSb,CRbFgSb,
     &                       CRtFgSt,CLtFgSt,CLsFgSs,CRsFgSs
      

      mq(1)=mt
      mq(2)=mb
     
      do h=1,5
      CSq(1,h)=CSfup(h)
      CSq(2,h)=CSfdown(h)
      CPq(1,h)=CPfup(h)
      CPq(2,h)=CPfdown(h)
      end do

      dG_H=0d0
      do q=1,2
      do h=1,5
      a=Mh(h)**2/mq(q)**2
      dG_H=4d0*sqrt(2d0)*Gf*g3**3*CSq(q,h)*CPq(q,h)*hFUNC_EDM(a)/
     &     (4d0*pi)**4
      end do
      end do
      
      return
      end
      
      
      subroutine EDM_dG_glu(dG_glu)
      implicit none
     
      double precision dG_glu
      
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      double precision absM3,phiM3
      
      double complex CLChiFeSe(5,2),CRChiFeSe(5,2),CLChiFdSd(5,4),
     &               CRChiFdSd(5,4),CLChiFuSu(5,2),CRChiFuSu(5,2),
     &               ChStauStau(5,2,2),ChSbSb(5,2,2),ChStSt(5,2,2),
     &               CShChaCha(5,2,2),CPhChaCha(5,2,2)
      double precision CSfdown(5),CPfdown(5),CSfup(5),CPfup(5)
      double complex  CPHpChiCha(5,2),CSHpChiCha(5,2),CLWChiCha(5,2),
     &                 CRWChiCha(5,2),CPHpud(2),CSHpud(2),CSHpve,CPHpve 
      double complex CLChaFdSu(2,4),CRChaFdSu(2,4),CLChaFuSd(2,2),
     &               CRChaFuSd(2,2),CLChaFeSv(2),CRChaFeSv(2),
     &               CLdFgSd(2),CRdFgSd(2),CRuFgSu(2),CLuFgSu(2),
     &               CLbFgSb(2),CRbFgSb(2),CRtFgSt(2),CLtFgSt(2),
     &               CLsFgSs(2),CRsFgSs(2)
      
      double precision mq(2),msq(2,2)
      double complex CLSqglu(2,2),CRSqglu(2,2)
      double precision HcapFUNC_EDM,a,b,c
  
      integer q,j
      double precision pi
      parameter (pi = 2d0*Asin(1d0))
      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /gluino/ absM3,phiM3
      common/ couplingsEDM / CLChiFeSe,CRChiFeSe,CLChiFdSd,CRChiFdSd,
     &                       CLChiFuSu,CRChiFuSu,ChStauStau,ChSbSb,
     &                       ChStSt,CShChaCha,CPhChaCha,CSHpChiCha,
     &                       CPHpChiCha,CLWChiCha,CRWChiCha,
     &                       CSfdown,CPfdown,CSfup,CPfup,
     &                       CPHpud,CSHpud,CSHpve,CPHpve,
     &                       CLChaFdSu,CRChaFdSu,CLChaFuSd,CRChaFuSd,
     &                       CLChaFeSv,CRChaFeSv,CLdFgSd,CRdFgSd,
     &                       CRuFgSu,CLuFgSu,CLbFgSb,CRbFgSb,
     &                       CRtFgSt,CLtFgSt,CLsFgSs,CRsFgSs
      

      mq(1)=mt
      mq(2)=mb
      
      msq(1,1)=MSu(5)
      msq(1,2)=MSu(6)
      msq(2,1)=MSd(5)
      msq(2,2)=MSd(6)
     
      do q=1,2
      CLSqglu(1,q)=CLtFgSt(q)
      CLSqglu(2,q)=CLbFgSb(q)
      CRSqglu(1,q)=CRtFgSt(q)
      CRSqglu(2,q)=CRbFgSb(q)
      end do
      
      dG_glu=0d0
      do q=1,2
      a=msq(q,1)**2/absM3**2
      b=msq(q,2)**2/absM3**2
      c=mq(q)**2/absM3**2
      do j=1,2
      dG_glu=dG_glu-3d0*g3**3*mq(q)*msq(q,j)**2/absM3**2*
     &       AIMAG(CONJG(CRSqglu(q,j))*CLSqglu(q,j))*
     &       HcapFUNC_EDM(a,b,c)/2d0/pi/(4d0*pi*absM3)**3
      end do
      end do
      
      return 
      end
      
      
      subroutine dThallium(dEe_one,dEe_two,C4de,C4Se,C4ge,md,ms,v,dTl)
      
      implicit none
      
      double precision dEe_one,dEe_two,C4de,C4se,C4ge
      double precision md,ms,v
      double precision dTl(6)
      double precision C4S,kap
      
! contribution from one-loop EDMs
      dTl(1)=-585*dEe_one
     
! contribution from two-loop EDMs
      dTl(2)=-585*dEe_two
      
! contribution from four fermion operator
! central value of kap
      kap=0.5d0
      C4S=C4de*29d-3/md+C4se*kap*220d-3/ms+0.1d0*C4ge/v
      dTl(3)=-8.5d-13*C4S

! lower value of kap
      kap=0.25d0
      C4S=C4de*29d-3/md+C4se*kap*220d-3/ms+0.1d0*C4ge/v
      dTl(4)=-8.5d-13*C4S

! high value of kap
      kap=0.75d0
      C4S=C4de*29d-3/md+C4se*kap*220d-3/ms+0.1d0*C4ge/v
      dTl(5)=-8.5d-13*C4S
      
! combined value
      dTl(6)=dTl(1)+dTl(2)+dTl(3)
      
      return
      end
      
      
      
      subroutine dn_CQM(dEd_one,dEu_one,dEd_two,dEu_two,dCd_one,
     &                   dCu_one,dCd_BZ,dCu_BZ,dG_all,dnCQM)
      
      implicit none
      
      double precision dEd_one,dEu_one,dEd_two,dEu_two,dCd_one,
     &                 dCu_one,dCd_BZ,dCu_BZ,dG_all,dnCQM(6)
     
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      
      double precision dd,du
      
      double precision pi
      parameter (pi = 2d0*Asin(1d0))
      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
     
! only contributions from EDMs
      dd=1.53d0*(dEd_one+dEd_two)
      du=1.53d0*(dEu_one+dEu_two)
      dnCQM(1)=4d0*dd/3d0-du/3d0

! only contributions from CEMDS
      dd=3.4d0*(dCd_one+dCd_BZ)*g3/4d0/pi
      du=3.4d0*(dCu_one+dCu_BZ)*g3/4d0/pi
      dnCQM(2)=4d0*dd/3d0-du/3d0

! only contributions from Weinbergoperator
      dd=3.4d0*1.19d0/4d0/pi*dG_all
      du=3.4d0*1.19d0/4d0/pi*dG_all
      dnCQM(3)=4d0*dd/3d0-du/3d0
      
! only one-loop contributions
      dd=1.53d0*(dEd_one)+3.4d0*(dCd_one)*g3/4d0/pi
      du=1.53d0*(dEu_one)+3.4d0*(dCu_one)*g3/4d0/pi
      dnCQM(4)=4d0*dd/3d0-du/3d0

! only two-loop contributions
      dd=1.53d0*(dEd_two)+3.4d0*(dCd_BZ)*g3/4d0/pi+
     .   3.4d0*1.19d0/4d0/pi*dG_all
      du=1.53d0*(dEu_two)+3.4d0*(dCu_BZ)*g3/4d0/pi+
     .   3.4d0*1.19d0/4d0/pi*dG_all
      dnCQM(5)=4d0*dd/3d0-du/3d0
      
! sum of all
      dnCQM(6)=dnCQM(1)+dnCQM(2)+dnCQM(3)

      return
      end 
      
      
      
      
      subroutine dn_QCDsum(dEd_one,dEu_one,dEd_two,dEu_two,dCd_one,
     &                   dCu_one,dCd_BZ,dCu_BZ,dG_all,C4bd,mb,dnQCDsum)
     
      implicit none
      double precision dEd_one,dEu_one,dEd_two,dEu_two,dCd_one,
     &                 dCu_one,dCd_BZ,dCu_BZ,dG_all,C4bd,mb,dnQCDsum(7)
      double precision convfac,dEd,dEu,dCd,dCu,dnCEDM,dnG,dnC
     
      
      convfac=1.9732695d-14 !converts from 1/GeV to cm
! only EDM contributions
      dEd=dEd_one+dEd_two
      dEu=dEu_one+dEu_two
      dCd=0d0
      dCu=0d0
      dnCEDM=1.4d0*(dEd-0.25d0*dEu)+1.1d0*(dCd+0.5d0*dCu)
      dnG=0d0
      dnC=0d0
      dnQCDsum(1)=dnCEDM+dnG+dnC

! only CEDM contributions
      dEd=0d0
      dEu=0d0
      dCd=dCd_one+dCd_BZ
      dCu=dCu_one+dCu_BZ
      dnCEDM=1.4d0*(dEd-0.25d0*dEu)+1.1d0*(dCd+0.5d0*dCu)
      dnG=0d0
      dnC=0d0
      dnQCDsum(2)=dnCEDM+dnG+dnC

! only Weinbergoperator
      dEd=0d0
      dEu=0d0
      dCd=0d0
      dCu=0d0
      dnCEDM=1.4d0*(dEd-0.25d0*dEu)+1.1d0*(dCd+0.5d0*dCu)
      dnG=8.5d0*20d-3*dG_all
      dnC=0d0
      dnQCDsum(3)=dnCEDM+dnG+dnC

! only four fermion couplingsEDM
      dEd=0d0
      dEu=0d0
      dCd=0d0
      dCu=0d0
      dnCEDM=1.4d0*(dEd-0.25d0*dEu)+1.1d0*(dCd+0.5d0*dCu)
      dnG=0d0
      dnC=2.6d-3*(1d0+3d0/4d0)*C4bd/mb*convfac
      dnQCDsum(4)=dnCEDM+dnG+dnC

! only one-loop
      dEd=dEd_one
      dEu=dEu_one
      dCd=dCd_one
      dCu=dCu_one
      dnCEDM=1.4d0*(dEd-0.25d0*dEu)+1.1d0*(dCd+0.5d0*dCu)
      dnG=0d0
      dnC=0d0
      dnQCDsum(5)=dnCEDM+dnG+dnC

! only two-loop
      dEd=dEd_two
      dEu=dEu_two
      dCd=dCd_BZ
      dCu=dCu_BZ
      dnCEDM=1.4d0*(dEd-0.25d0*dEu)+1.1d0*(dCd+0.5d0*dCu)
      dnG=8.5d0*20d-3*dG_all
      dnC=0d0
      dnQCDsum(6)=dnCEDM+dnG+dnC

! all contributions
      dEd=dEd_one+dEd_two
      dEu=dEu_one+dEu_two
      dCd=dCd_one+dCd_BZ
      dCu=dCu_one+dCu_BZ
      dnCEDM=1.4d0*(dEd-0.25d0*dEu)+1.1d0*(dCd+0.5d0*dCu)
      dnG=8.5d0*20d-3*dG_all
      dnC=2.6d-3*(1d0+3d0/4d0)*C4bd/mb*convfac
      dnQCDsum(7)=dnCEDM+dnG+dnC
      
      return
      end
      
      
      
      subroutine dn_PQM(dEd_one,dEd_two,dEu_one,dEu_two,dEs_one,
     &                  dEs_two,dnPQM)
     
      implicit none
      
      double precision dEd_one,dEd_two,dEu_one,dEu_two,dEs_one,
     &                  dEs_two,dnPQM(6)
      
      ! only down contributions
      dnPQM(1)=1.53d0*0.746d0*(dEd_one+dEd_two)
      
      ! only up contributions
      dnPQM(2)=-1.53d0*0.508d0*(dEu_one+dEu_two)
      
      ! only strange contributions
      dnPQM(3)=-1.53d0*0.226d0*(dEs_one+dEs_two)
      
      !only one-loop
      dnPQM(4)=1.53d0*(0.746d0*dEd_one-0.508d0*dEu_one-0.226d0*dEs_one)
      
      !only two-loop
      dnPQM(5)=1.53d0*(0.746d0*dEd_two-0.508d0*dEu_two-0.226d0*dEs_two)
      
      !all contributions
      dnPQM(6)=1.53d0*(0.746d0*(dEd_one+dEd_two)-
     &                 0.508d0*(dEu_one+dEu_two)-
     &                 0.226d0*(dEs_one+dEs_two))

      return 
      end
      
      
      
      
      subroutine dEHg(dEe,dCu,dCd,dHg)
      
      implicit none
      
      double precision dEe,dCu,dCd,dHg(4)
      double precision CS,CP,CPp,kap
      double precision C4de,C4se,C4be,C4bd,C4ge,C4ec,C4et,C4dd,
     &                 C4ds
      double precision S(4),gpiNN1,gpiNN0
      
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      integer i
      
      common/fourfermionop/ C4de,C4se,C4be,C4bd,C4ge,C4ec,C4et,C4dd,
     &                      C4ds
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      
      kap=0.5d0
      CS=C4de*29d-3/md+C4se*kap*220d-3/ms+0.1d0*C4ge/v
      CP=-0.375d0*(C4ec/mc+C4et/mt+C4be/mb+C4se/ms)
      CPp=-0.806d0*C4de/md-0.181d0*(C4ec/mc+C4et/mt+C4be/mb+C4se/ms)
      
      CS=CS*1.9732695d-14
      CP=CP*1.9732695d-14
      CPp=CPp*1.9732695d-14
      
      gpiNN0=0.4d-12*(dCu+dCd)/10d-26
      gpiNN1=2d-12*(dCu-dCd)/10d-26
     &      -8d-3*(0.5d0*C4dd/md+3.3*kap*C4ds/ms+(1-0.25*kap)*C4bd/mb) 
      
      S(1)=(1.8d-3*gpiNN1)*1.9732695d-14
      S(2)=(7.6d-6*gpiNN0+1d-3*gpiNN1)*1.9732695d-14
      S(3)=(1.3d-4*gpiNN0+1.4d-3*gpiNN1)*1.9732695d-14
      S(4)=(3.1d-4*gpiNN0+9.5d-5*gpiNN1)*1.9732695d-14
      
      do i=1,4
      dHg(i)=S(i)+10d-2*dEe+3.5d-3*CS+4d-4*(CP+4d0*CPp)
      end do
      
      return
      end
      
      
      
      subroutine EDM_couplings
      
      implicit none
      
      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
      double precision ZH5(5,5),ZH(6,6)
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3)
      double precision absM3,phiM3
      double complex  ChHpWmA(6,2),ChHmWpA(2,6),ChHpWmZ(6,2),
     &                ChHmWpZ(2,6),ChhWmWp(6,6),ChhAZ(6,6),ChhZZ(6,6),
     &                ChHpWm(6,2),ChHmWp(2,6),ChhZ(6,6),ChWmWp(6),
     &                ChZZ(6),ChSdmSdp(6,6,6),ChSemSep(6,6,6),
     &                ChSupSum(6,6,6),ChSvSvconj(6),ChHmHp(2,2,6),
     &                ChhSemSep(6,6,6,6),ChhSvSvconj(6,6),
     &                ChhHmHp(2,6,2,6),ChhSupSum(6,6,6,6),
     &                ChhSdmSdp(6,6,6,6),CLhChapCham(2,2,6),
     &                CRhChapCham(2,2,6),CLhFepFem(3,3,6),
     &                CRhFepFem(3,3,6),CLhFdpFdm(3,3,6),
     &                CRhFdpFdm(3,3,6),CLhFumFup(3,3,6),
     &                CRhFumFup(3,3,6),ChU3U3(6),ChU2U2(6),ChU4U4(6),
     &                Chhh(6,6,6),Chhhh(6,6,6,6),CLhChiChi(5,5,6),
     &                CRhChiChi(5,5,6),CHmHpSvSv(3,2,3,2),
     &                CHmHpSdmSdp(6,2,6,2),CHmHpSupSum(6,2,6,2),
     &                CHmHpSemSep(6,2,6,2),CHmSepSv(3,6,2),
     &                CHpSemSv(6,3,2),CHmSupSdp(6,6,2),
     &                CHpSumSdm(6,6,2),CLHpChiCha(5,2,2),
     &                CRHpChiCha(5,2,2),CLHmChiCha(2,5,2),
     &                CRHmChiCha(2,5,2)
      
      double complex CLChiFeSe(5,2),CRChiFeSe(5,2),CLChiFdSd(5,4),
     &               CRChiFdSd(5,4),CLChiFuSu(5,2),CRChiFuSu(5,2),
     &               ChStauStau(5,2,2),ChSbSb(5,2,2),ChStSt(5,2,2),
     &               CShChaCha(5,2,2),CPhChaCha(5,2,2)
      double precision CSfdown(5),CPfdown(5),CSfup(5),CPfup(5)
      double complex  CPHpChiCha(5,2),CSHpChiCha(5,2),CLWChiCha(5,2),
     &                 CRWChiCha(5,2),CPHpud(2),CSHpud(2),CSHpve,CPHpve 
      double complex CLChaFdSu(2,4),CRChaFdSu(2,4),CLChaFuSd(2,2),
     &               CRChaFuSd(2,2),CLChaFeSv(2),CRChaFeSv(2),
     &               CLdFgSd(2),CRdFgSd(2),CRuFgSu(2),CLuFgSu(2),
     &               CLbFgSb(2),CRbFgSb(2),CRtFgSt(2),CLtFgSt(2),
     &               CLsFgSs(2),CRsFgSs(2)
      double complex CSgluon(5)
      double complex vZuu,aZuu,vZdd,aZdd,vZee,aZee,vZchacha(2,2),
     &               aZchacha(2,2)
      double precision C4de,C4se,C4be,C4bd,C4ge,C4ec,C4et,C4dd,
     &                      C4ds
      double precision sw,cw,Ydtemp,Yutemp,mup(2),mdown(2)
      integer chi1,se1,sd1,su1,h1,i,j,cha1,gt3
      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /gluino/ absM3,phiM3
      common /coupl/ ChHpWmA,ChHmWpA,ChHpWmZ,ChHmWpZ,ChhWmWp,
     &               ChhAZ,ChhZZ,ChHpWm,ChHmWp,ChhZ,ChWmWp,ChZZ,
     &               ChSdmSdp,ChSemSep,ChSupSum,ChSvSvconj,ChHmHp,
     &               ChhSemSep,ChhSvSvconj,ChhHmHp,ChhSupSum,ChhSdmSdp,
     &               CLhChapCham,CRhChapCham,CLhFepFem,CRhFepFem,
     &               CLhFdpFdm,CRhFdpFdm,CLhFumFup,CRhFumFup,ChU3U3,
     &               ChU2U2,ChU4U4,Chhh,Chhhh,CLhChiChi,CRhChiChi,
     &               CHmHpSvSv,CHmHpSdmSdp,CHmHpSupSum,CHmHpSemSep,
     &               CHmSepSv,CHpSemSv,CHmSupSdp,CHpSumSdm,CRHpChiCha,
     &               CLHpChiCha,CRHmChiCha,CLHmChiCha
      common/ couplingsEDM / CLChiFeSe,CRChiFeSe,CLChiFdSd,CRChiFdSd,
     &                       CLChiFuSu,CRChiFuSu,ChStauStau,ChSbSb,
     &                       ChStSt,CShChaCha,CPhChaCha,CSHpChiCha,
     &                       CPHpChiCha,CLWChiCha,CRWChiCha,
     &                       CSfdown,CPfdown,CSfup,CPfup,
     &                       CPHpud,CSHpud,CSHpve,CPHpve,
     &                       CLChaFdSu,CRChaFdSu,CLChaFuSd,CRChaFuSd,
     &                       CLChaFeSv,CRChaFeSv,CLdFgSd,CRdFgSd,
     &                       CRuFgSu,CLuFgSu,CLbFgSb,CRbFgSb,
     &                       CRtFgSt,CLtFgSt,CLsFgSs,CRsFgSs
      common/ couplingsEDM2/ vZuu,aZuu,vZdd,aZdd,vZee,aZee,vZchacha,
     &                       aZchacha 
      common/fourfermionop/ C4de,C4se,C4be,C4bd,C4ge,C4ec,C4et,C4dd,
     &                      C4ds
      
      do chi1=1,5
      do se1=1,2
      CLChiFeSe(chi1,se1)=(g1*CONJG(NN(chi1,1))*ZE(se1,1))/Sqrt(2d0) + 
     -                    (g2*CONJG(NN(chi1,2))*ZE(se1,1))/Sqrt(2d0) - 
     -                    CONJG(NN(chi1,3))*Ye(1)*ZE(se1,2)
      CRChiFeSe(chi1,se1)=-(Sqrt(2d0)*g1*ZE(se1,2)*NN(chi1,1)) - 
     -                      Ye(1)*ZE(se1,1)*NN(chi1,3)
      end do
      
      do sd1=1,4
      if(sd1.le.2) then
      Ydtemp=Yd(1)
      else 
      Ydtemp=Yd(2)
      end if
      CLChiFdSd(chi1,sd1)=-(g1*CONJG(NN(chi1,1))*ZD(sd1,1))/
     -                     (3.*Sqrt(2d0))+(g2*CONJG(NN(chi1,2))*
     -                     ZD(sd1,1))/Sqrt(2d0) - 
     -                     CONJG(NN(chi1,3))*Ydtemp*ZD(sd1,2)
      CRChiFdSd(chi1,sd1)=-(Sqrt(2d0)*g1*ZD(sd1,2)*NN(chi1,1))/3. -
     -                      Ydtemp*ZD(sd1,1)*NN(chi1,3)
      end do
      
      do su1=1,2
     
      CLChiFuSu(chi1,su1)=-(Sqrt(2d0)*g1*CONJG(NN(chi1,1))*ZU(su1,1) + 
     -                    3*Sqrt(2d0)*g2*CONJG(NN(chi1,2))*ZU(su1,1) + 
     -                    6*CONJG(NN(chi1,4))*Yu(1)*ZU(su1,2))/
     -                    (6.*exp((0d0,1d0)*phiu/2d0))
      CRChiFuSu(chi1,su1)=(-3*Yu(1)*NN(chi1,4)*ZU(su1,1)+2*Sqrt(2d0)*
     -                    g1*NN(chi1,1)*ZU(su1,2))/
     -                    (3.*exp(-(0d0,1d0)*phiu/2d0))
      end do
      
      end do
      
      do cha1=1,2
      do sd1=1,2
      CLChaFuSd(cha1,sd1)=(-(g2*CONJG(UM(cha1,1))*ZD(Sd1,1)) + 
     -                       CONJG(UM(cha1,2))*Yd(1)*ZD(Sd1,2))/
     -                       exp(((0d0,1d0)*phiu)/2d0)
      CRChaFuSd(cha1,sd1)=exp(((0d0,1d0)*phiu)/2d0)*
     -                    UP(cha1,2)*Yu(1)*ZD(Sd1,1)
      end do
      do su1=1,4
      if(su1.le.2) then
      Ydtemp=Yd(1)
      Yutemp=Yu(1)
      else 
      Ydtemp=Yd(2)
      Yutemp=Yu(2)
      end if
      CLChaFdSu(cha1,su1)=-(g2*CONJG(UP(cha1,1))*ZU(su1,1)) + 
     -                      CONJG(UP(cha1,2))*Yutemp*ZU(su1,4)
      CRChaFdSu(cha1,su1)=Ydtemp*UM(cha1,2)*ZU(su1,1)
      end do
      CLChaFeSv(cha1)=-g2*CONJG(UP(cha1,1))
      CRChaFeSv(cha1)=Ye(1)*UM(cha1,2)
      end do
      
      
      do i=1,2
      do j=1,2
      do h1=1,5
      ChStauStau(h1,i,j)=-(0d0,1d0)*ChSemSep(i+4,j+4,h1+1)/v
      ChSbSb(h1,i,j)=-(0d0,1d0)*ChSdmSdp(i+4,j+4,h1+1)/v
      ChStSt(h1,i,j)=-(0d0,1d0)*ChSupSum(i+4,j+4,h1+1)/v
      end do
      end do
      end do
      
      
      do i=1,2
      do j=1,2
      do h1=1,5
      CShChaCha(h1,i,j)=(0d0,1d0)/g2/Sqrt(2d0)*
     &                  (CRhChapCham(i,j,h1+1)+CLhChapCham(i,j,h1+1))
      CPhChaCha(h1,i,j)=1d0/g2/Sqrt(2d0)*
     &                  (CRhChapCham(i,j,h1+1)-CLhChapCham(i,j,h1+1))
      end do
      end do
      end do
      
      do h1=1,5
      CSfdown(h1)=ZH5(h1,3)/Cos(beta)
      CPfdown(h1)=-ZH5(h1,1)*tanb
      CSfup(h1)=ZH5(h1,4)/sin(beta)
      CPfup(h1)=-ZH5(h1,1)/tanb
      end do
      
      do Chi1=1,5
      do Cha1=1,2
      CSHpChiCha(Chi1,Cha1)=CONJG((0d0,1d0)*(CRHpChiCha(Chi1,Cha1,2)+
     &             CLHpChiCha(Chi1,Cha1,2))/2d0/g2*Sqrt(2d0))
      CPHpChiCha(Chi1,Cha1)=CONJG(CRHpChiCha(Chi1,Cha1,2)-
     &             CLHpChiCha(Chi1,Cha1,2))/2d0/g2*Sqrt(2d0)
      end do
      end do
      
      mup(1)=mu
      mup(2)=mc
      mdown(1)=md
      mdown(2)=ms
      do i=1,2
      CPHpud(i)=((0d0,1d0)/2d0*(mup(i)/tan(beta) - 
     &          mdown(i)*Tan(beta)))/mup(i)
      CSHpud(i)=(mup(i)/tan(beta) + mdown(i)*Tan(beta))/(2d0*mup(i))
      end do
     
      CSHpve=Tan(beta)/2
      CPHpve=-(0d0,1d0)*tan(beta)/2d0
      
      do chi1=1,5
      do cha1=1,2
      CLWChiCha(chi1,cha1)=Sqrt(2d0)*CONJG(UM(cha1,1))*NN(chi1,2) + 
     &                     CONJG(UM(cha1,2))*NN(chi1,3)
      CRWChiCha(chi1,cha1)=Sqrt(2d0)*CONJG(NN(chi1,2))*UP(cha1,1) - 
     &                     CONJG(NN(chi1,4))*UP(cha1,2)
      end do
      end do
      
      do gt3=1,2
      CLuFgSu(gt3)=((0,1)*g3*CONJG(ZU(gt3,2)))/
     -             (Sqrt(2d0)*exp(((0,1)*(phiu+phiM3))/2d0))
      CRuFgSu(gt3)=(-(0,1)*exp(((0,1)*(phiu+phiM3))/2d0)*
     -              g3*CONJG(ZU(gt3,1)))/Sqrt(2d0)
     
      CLdFgSd(gt3)=((0,1)*g3*CONJG(ZD(gt3,2)))/
     -             (Sqrt(2d0)*exp(((0,1)*(phiM3))/2d0))
      CRdFgSd(gt3)=(-(0,1)*exp(((0,1)*(phiM3))/2d0)*
     -              g3*CONJG(ZD(gt3,1)))/Sqrt(2d0)
     
      CLsFgSs(gt3)=((0,1)*g3*CONJG(ZD(gt3+2,2)))/
     -             (Sqrt(2d0)*exp(((0,1)*(phiM3))/2d0))
      CRsFgSs(gt3)=(-(0,1)*exp(((0,1)*(phiM3))/2d0)*
     -              g3*CONJG(ZD(gt3+2,1)))/Sqrt(2d0)
     
      CLtFgSt(gt3)=((0,1)*g3*CONJG(ZU(gt3+4,6)))/
     -             (Sqrt(2d0)*exp(((0,1)*(phiu+phiM3))/2d0))
      CRtFgSt(gt3)=(-(0,1)*exp(((0,1)*(phiu+phiM3))/2d0)*
     -              g3*CONJG(ZU(gt3+4,5)))/Sqrt(2d0)
     
      CLbFgSb(gt3)=((0,1)*g3*CONJG(ZD(gt3+4,6)))/
     -             (Sqrt(2d0)*exp(((0,1)*(phiM3))/2d0))
      CRbFgSb(gt3)=(-(0,1)*exp(((0,1)*(phiM3))/2d0)*
     -              g3*CONJG(ZD(gt3+4,5)))/Sqrt(2d0)
      end do
      
      
      cw=MW**2/MZ**2
      sw=sqrt(1d0-cw**2)
      vZuu=0.25d0-(2d0*sw**2)/3d0
      aZuu=0.25d0
      vZdd=-0.25d0+sw**2/3d0
      aZdd=-0.25d0
      vZee=-0.25d0+sw**2
      aZee=-0.25d0
      do i=1,2
      do j=1,2
      vZchacha(i,j)=(CONJG(UM(j,2))*UM(i,2))/4d0 + 
     -              (CONJG(UP(i,2))*UP(j,2))/4d0
      if (i.eq.j) then
      vZchacha(i,i)=vZchacha(i,i)-cw**2
      end if
      aZchacha(i,j)=(CONJG(UM(j,2))*UM(i,2))/4d0 - 
     &              (CONJG(UP(i,2))*UP(j,2))/4d0
      end do
      end do
       
      do h1=1,5
      CSgluon(h1)=2d0/3d0*CSfup(h1)-v**2/12d0*
     &       (ChStSt(h1,1,1)/MSu(5)**2+ChStSt(h1,2,2)/MSu(6)**2)+
     &       2d0*0.875d0*CSfdown(h1)-v**2/12d0*
     &       (ChSbSb(h1,1,1)/MSd(5)**2+ChSbSb(h1,2,2)/MSd(6)**2)
      end do
       
      !Fourfermion operators
      C4de=0d0
      C4dd=0d0
      C4ds=0d0
      C4se=0d0
      C4ec=0d0
      C4et=0d0
      C4be=0d0
      C4bd=0d0
      C4ge=0d0
      do h1=1,5
      C4de=C4de+me*md/v**2*CSfdown(h1)*CPfdown(h1)/Mh(h1)**2
      C4dd=C4dd+md*md/v**2*CSfdown(h1)*CPfdown(h1)/Mh(h1)**2
      C4ds=C4ds+md*ms/v**2*CSfdown(h1)*CPfdown(h1)/Mh(h1)**2
      C4se=C4se+me*ms/v**2*CSfdown(h1)*CPfdown(h1)/Mh(h1)**2
      C4ec=C4ec+me*mc/v**2*CSfdown(H1)*CPfup(h1)/Mh(h1)**2
      C4et=C4et+me*mt/v**2*CSfdown(H1)*CPfup(h1)/Mh(h1)**2
      C4be=C4be+me*mb/v**2*CSfdown(h1)*CPfdown(h1)/Mh(h1)**2
      C4bd=C4bd+mb*md/v**2*CSfdown(h1)*CPfdown(h1)/Mh(h1)**2
      C4ge=C4ge+Realpart(me/v*CPfdown(h1)*CSgluon(h1)/Mh(h1)**2)
      end do
      
      return
      end
      
      
      
